import { OnDestroy, OnInit } from '@angular/core';
import { AbstractControl, FormGroup } from '@angular/forms';
import { AngularFireAuth } from '@angular/fire/auth';
import { AuthProcessService, AuthProvider } from '../../services/auth-process.service';
import { Subscription } from 'rxjs/internal/Subscription';
import { NgbTabset } from '@ng-bootstrap/ng-bootstrap';
import { AlertService } from '../../services/alert.service';
export declare const EMAIL_REGEX: RegExp;
export declare const PHONE_NUMBER_REGEX: RegExp;
export declare class AuthComponent implements OnInit, OnDestroy {
    private platformId;
    auth: AngularFireAuth;
    authProcess: AuthProcessService;
    alertService: AlertService;
    tabs: NgbTabset;
    providers: string[] | string;
    guestEnabled: boolean;
    onSuccess: any;
    onError: any;
    authProvider: typeof AuthProvider;
    passwordResetWished: any;
    signInFormGroup: FormGroup;
    signUpFormGroup: FormGroup;
    resetPasswordFormGroup: FormGroup;
    onErrorSubscription: Subscription;
    authenticationError: boolean;
    passReset: boolean;
    authProviders: typeof AuthProvider;
    signInEmailFormControl: AbstractControl;
    sigInPasswordFormControl: AbstractControl;
    sigUpNameFormControl: AbstractControl;
    sigUpEmailFormControl: AbstractControl;
    sigUpPasswordFormControl: AbstractControl;
    sigUpPasswordConfirmationFormControl: AbstractControl;
    resetPasswordEmailFormControl: AbstractControl;
    constructor(platformId: Object, auth: AngularFireAuth, authProcess: AuthProcessService, alertService: AlertService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    readonly color: string;
    resetPassword(): void;
    selectResetPasswordTab(): void;
    private _initSignInFormGroupBuilder;
    private _initSignUpFormGroupBuilder;
    private _initResetPasswordFormGroupBuilder;
}
