import { InjectionToken, ModuleWithProviders } from '@angular/core';
import { FirebaseAppConfig } from '@angular/fire';
import { NgBootstrapAuthFirebaseUIConfig } from './interfaces/config.interface';
export { AuthComponent } from './components/auth/auth.component';
export { EmailConfirmationComponent } from './components/email-confirmation/email-confirmation.component';
export { ProgressBarComponent } from './components/progress-bar/progress-bar.component';
export { AuthProvidersComponent } from './components/providers/auth.providers.component';
export { NgbAlertsContainerComponent } from './components/alerts-container/ngb-alerts-container.component';
export { AuthProcessService, AuthProvider } from './services/auth-process.service';
export { FirestoreSyncService } from './services/firestore-sync.service';
export { AlertService } from './services/alert.service';
export { NgBootstrapAuthFirebaseUIConfig } from './interfaces/config.interface';
export { IAlert } from './interfaces/ialert.interface';
export declare const NgBootstrapAuthFirebaseUIConfigToken: InjectionToken<NgBootstrapAuthFirebaseUIConfig>;
export declare class NgbAuthFirebaseUIModule {
    static forRoot(configFactory: FirebaseAppConfig, appNameFactory?: () => string, config?: NgBootstrapAuthFirebaseUIConfig): ModuleWithProviders;
}
